#version 430 core

// Material properties
uniform float bloom_thresh_min = 0.9f;
uniform float bloom_thresh_max = 1.2f;


// Input variables
in VertexData
{
	vec2 tex_coord;
} inData;

// Output variables
layout (location = 0) out vec4 final_color;

// Texture to be filtered out - should be texture with lit scene
layout (binding = 0) uniform sampler2D input_tex;

void main()
{
	vec4 col = textureLod(input_tex, inData.tex_coord, 0);
	
	// Calculate luminance
	float Y = dot(vec3(col), vec3(0.299f, 0.587f, 0.144f));
	
	// Threshold color based on its luminance and write to output
	col = /*col * 4.f * */ smoothstep(bloom_thresh_min, bloom_thresh_max, Y);
	final_color = vec4(col.xyz, 1.f);

}